
;;;Program Name: Spot_elevation.lsp
;;;
;;;Program Purpose: Label spot elevations on an AutoCAD drawing

(defun c:spot	(/ result z_pt field_position elevation pt)
  (vl-load-com)
  (setq cnt 1)
  (setq result 4)
  (while (> result 1)
    (setq dcl_id4 (load_dialog
		    "spot.dcl"
		  )
    )
    (if	(not (new_dialog "spot" dcl_id4))
      (exit)
    )
    (start_list "layer_pop_list")
    (setq ll  '()
	  nl  (tblnext "layer" T)
	  idx 0
    )
    (while nl
      (if (= (getvar "clayer") (cdr (assoc 2 nl)))
	(setq cl  idx
	      idx (1+ idx)
	)
      )
      (setq ll (append ll (list (cdr (assoc 2 nl))))
	    nl (tblnext "layer")
      )
    )
    (mapcar 'add_list ll)
    (end_list)
    (set_tile "layer_pop_list" (ITOA CL))
    (start_list "style_pop_list")
    (setq ll_s	'()
	  nl_s	(tblnext "style" T)
	  idx_s	0
    )
    (while nl_s
      (if (= (getvar "textstyle") (cdr (assoc 2 nl_s)))
	(setq cl_s  idx_s
	      idx_s (1+ idx_s)
	)
      )
      (setq ll_s (append ll_s (list (cdr (assoc 2 nl_s))))
	    nl_s (tblnext "style")
      )
    )
    (mapcar 'add_list ll_s)
    (end_list)
;;;~~~~~~~~~~~~~~Registry~~~~~~~~~~~~~~~~~~Registry~~~~~~~~~~~~~~~~~~~
    (setq regInformation
	   (vl-registry-descendents
	     "HKEY_CURRENT_USER\\Software\\spot_elevation"
	     "1"
	   )
    )
    (if	(/= regInformation nil)
      (progn
	(set_tile "rotation"
		  (vl-registry-read
		    "HKEY_CURRENT_USER\\Software\\spot_elevation"
		    "rotation"
		  )
	)
	(set_tile "point_number"
		  (vl-registry-read
		    "HKEY_CURRENT_USER\\Software\\spot_elevation"
		    "point_number"
		  )
	)
      )
      (progn
	(set_tile "point_number" "100")
	(set_tile "rotation" "45")
      )
    )
;;;~~~~~~~~~~~~~~Registry~~~~~~~~~~~~~~~~~~Registry~~~~~~~~~~~~~~~~~~~
    (set_tile "description" "Spot Elevation")
    (set_tile "style_pop_list" (ITOA CL_s))
    (set_tile "current_layer" "1")
    (set_tile "current_style" "1")
    (set_tile "donut_marker" "1")
    (set_tile "field_layer" (getvar "clayer"))
    (set_tile "field_style" (getvar "cmlstyle"))
    (if	(/= field_position nil)
      (set_tile "field_position" field_position)
      (set_tile "field_position" "No point selected")
    )
    (if	(/= elevation nil)
      (set_tile "elevation" (rtos elevation))
      (progn
	(mode_tile "elevation" 1)
	(mode_tile "rotation" 1)
	(mode_tile "description" 1)
	(mode_tile "point_number" 1)
	(mode_tile "c1" 1)
	(mode_tile "c2" 1)
	(mode_tile "c3" 1)
	(mode_tile "field_style" 1)
	(mode_tile "field_layer" 1)
      )
    )
    (mode_tile "layer_pop_list" 1)
    (mode_tile "create_layer_box" 1)
    (mode_tile "style_pop_list" 1)
    (action_tile
      "current_layer"
      "(progn (mode_tile \"layer_pop_list\"  (atoi $value))
            (mode_tile \"create_layer_box\" (atoi $value))
            (mode_tile \"field_layer\" (- 1 (atoi $value))))"
    )
    (action_tile
      "select_layer"
      "(progn (mode_tile \"create_layer_box\"  (atoi $value))
            (mode_tile \"field_layer\"  (atoi $value))
            (mode_tile \"layer_pop_list\" (- 1 (atoi $value))))"
    )
    (action_tile
      "create_layer"
      "(progn (mode_tile \"layer_pop_list\"  (atoi $value))
            (mode_tile \"field_layer\"  (atoi $value))
            (mode_tile \"create_layer_box\" (- 1 (atoi $value))))"
    )
    (action_tile
      "current_style"
      "(progn (mode_tile \"style_pop_list\"  (atoi $value))
            (mode_tile \"field_style\"  (- 1 (atoi $value))))"
    )
    (action_tile
      "select_style"
      "(progn (mode_tile \"field_style\"  (atoi $value))
            (mode_tile \"style_pop_list\" (- 1 (atoi $value))))"
    )
    (start_image "test")
    (setq x (dimx_tile "test")
	  y (dimy_tile "test")
    )
    (slide_image 0 0 x y "/temp/donut.sld")
    (end_image)
    (action_tile
      "donut_marker"
      "(progn (start_image \"test\")
            (fill_image 0 0 x y 0)	
            (slide_image 0 0 x y \"/temp/donut.sld\")    
            (end_image))"
    )
    (action_tile
      "cross_marker"
      "(progn (start_image \"test\")
    	    (fill_image 0 0 x y 0)
            (slide_image 0 0 x y  \"/temp/cross.sld\")    
            (end_image))"
    )
    (action_tile
      "circle_marker"
      "(progn (start_image \"test\")
            (fill_image 0 0 x y 0)
            (slide_image 0 0 x y  \"/temp/circle.sld\")    
            (end_image))"
    )
    (action_tile
      "no_marker"
      "(progn (start_image \"test\")
            (fill_image 0 0 x y 0)    
            (end_image))"
    )
    (action_tile "accept" "(get_info)(done_dialog 1)")
    (action_tile "s_point" "(done_dialog 4)")
    (action_tile "cancel" "(setq result nil) (done_dialog 0)")
    (setq result (start_dialog))
    (if	(and (= result 1) (= pt nil))
      (progn
	(alert "No point Specified")
	(setq result 2
	      elevation	nil
	      field_position
	       nil
	)
      )
    )
    (if	(= result 4)
      (progn
	(setq pt (getpoint "\nPick insertion point : "))
	(setq field_position
	       (strcat (rtos (car pt))
		       ", "
		       (rtos (cadr pt))
		       ", "
		       (rtos (setq z_pt (caddr pt)))
	       )
	      elevation	z_pt
	)
      )
    )
  )
  (princ)
)
(defun get_info	()
  (setq	description	 (get_tile "description")
	elevation	 (get_tile "elevation")
	rotation	 (get_tile "rotation")
	point_number	 (get_tile "point_number")
	no_marker	 (get_tile "no_marker")
	cross_marker	 (get_tile "cross_marker")
	donut_marker	 (get_tile "donut_marker")
	circle_marker	 (get_tile "circle_marker")
	style_pop	 (nth (atoi (get_tile "style_pop_list")) ll_s)
	select_style	 (get_tile "select_style")
	current_style	 (get_tile "current_style")
	layer_pop	 (nth (atoi (get_tile "layer_pop_list")) ll)
	create_layer_box (get_tile "create_layer_box")
	select_layer	 (get_tile "select_layer")
	current_layer	 (get_tile "current_layer")
	create_layer	 (get_tile "create_layer")
  )
  (if (/= pt nil)
    (progn
      (setq pt (list (car pt) (cadr pt) (atof elevation)))
      (if (= no_marker "1")
	(no_marker_function)
      )
      (if (= circle_marker "1")
	(circle_marker_function)
      )
      (if (= donut_marker "1")
	(donut_marker_function)
      )
      (if (= cross_marker "1")
	(cross_marker_function)
      )
    )
  )
;;;~~~~~~~~~~~~~~Registry~~~~~~~~~~~~~~~~~~Registry~~~~~~~~~~~~~~~~~~~
  (if (/= point_number nil)
    (progn
      (vl-registry-write
	"HKEY_CURRENT_USER\\Software\\spot_elevation"
	"rotation"
	rotation
      )
      (vl-registry-write
	"HKEY_CURRENT_USER\\Software\\spot_elevation"
	"point_number"
	(itoa (+ 10 (atoi point_number)))
      )
    )
  )
;;;~~~~~~~~~~~~~~Registry~~~~~~~~~~~~~~~~~~Registry~~~~~~~~~~~~~~~~~~~
)
(defun no_marker_function ()
  (setq	object_1 nil
	object_2 nil
  )
  (make_object_function)
)
(defun circle_marker_function ()
  (setq	object_1 (LIST (CONS 0 "CIRCLE")
		       (CONS 10 pt)
		       (CONS 40 0.5)
		       (CONS 8 "pt_layer")
		 )
	object_2 nil
  )
  (make_object_function)
)
(defun donut_marker_function ()
  (setq	object_1
	 (list (cons 0 "LWPOLYLINE")
	       (cons 100 "AcDbEntity")
	       (cons 67 0)
	       (cons 410 "Model")
	       (cons 8 "0")
	       (cons 100 "AcDbPolyline")
	       (cons 90 2)
	       (cons 70 1)
	       (cons 43 0.5)
	       (cons 38 0.0)
	       (cons 39 0.0)
	       (cons 10 pt)
	       (cons 40 0.5)
	       (cons 41 0.5)
	       (cons 42 1.0)
	       (cons 10 (list (+ 0.5 (car pt)) (cadr pt) (caddr pt)))
	       (cons 40 0.5)
	       (cons 41 0.5)
	       (cons 42 1.0)
	 )
	object_2 nil
  )
  (make_object_function)
)
(defun cross_marker_function ()
  (setq	object_1 (list
		   (cons 0 "line")
		   (CONS 10 (list (- (car pt) 0.5) (cadr pt) (caddr pt)))
		   (cons 11 (list (+ (car pt) 0.5) (cadr pt) (caddr pt)))
		   (cons 8 "pt_layer")
		 )
	object_2 (LIST
		   (CONS 0 "line")
		   (CONS 10 (list (car pt) (- (cadr pt) 0.5) (caddr pt)))
		   (CONS 11 (list (car pt) (+ (cadr pt) 0.5) (caddr pt)))
		   (CONS 8 "pt_layer")
		 )
  )
  (make_object_function)
)
(defun make_object_function ()
  (setvar "cmdecho" 0)
  (setvar "cmddia" 0)
  (if (= current_layer "1")
    (setq layer (getvar "clayer"))
  )
  (if (= create_layer "1")
    (setq layer create_layer_box)
  )
  (if (= select_layer "1")
    (setq layer layer_pop)
  )
  (if (= current_style "1")
    (setq style (getvar "cmlstyle"))
  )
  (if (= select_style "1")
    (setq style style_pop)
  )
  (ENTMAKE (list (cons 0 "block")
		 (CONS 2 "point_block")
		 (cons 10 pt)
		 (cons 70 64)
	   )
  )
  (ENTMAKE object_1)
  (ENTMAKE object_2)
  (ENTMAKE
    (list (cons 0 "TEXT")
	  (cons 100 "AcDbEntity")
	  (cons 67 0)
	  (cons 410 "Model")
	  (cons 8 (strcat layer "_ptn"))
	  (cons 100 "AcDbText")
	  (cons	10
		(list (+ (car pt) (* 1.7143 (getvar "textsize")))
		      (+ (cadr pt) (* 1.7143 (getvar "textsize")))
		      (caddr pt)
		)
	  )
	  (cons 40 (getvar "textsize"))
	  (cons 1 point_number)
	  (cons 50 (* (atof rotation) (/ 3.14 180)))
	  (cons 41 1.0)
	  (cons 51 0)
	  (cons 7 style)
	  (cons 71 0)
	  (cons 72 0)
	  (cons 100 "AcDbText")
	  (cons 73 0)
    )
  )
  (ENTMAKE
    (list (cons 0 "TEXT")
	  (cons 100 "AcDbEntity")
	  (cons 67 0)
	  (cons 410 "Model")
	  (cons 8 layer)
	  (cons 100 "AcDbText")
	  (cons	10
		(list (+ (car pt) (* 1.7143 (getvar "textsize")))
		      (cadr pt)
		      (caddr pt)
		)
	  )
	  (cons 40 (getvar "textsize"))
	  (cons 1 elevation)
	  (cons 50 (* (atof rotation) (/ 3.14 180)))
	  (cons 41 1.0)
	  (cons 51 0)
	  (cons 7 style)
	  (cons 71 0)
	  (cons 72 0)
	  (cons 100 "AcDbText")
	  (cons 73 0)
    )
  )
  (ENTMAKE
    (list (cons 0 "TEXT")
	  (cons 100 "AcDbEntity")
	  (cons 67 0)
	  (cons 410 "Model")
	  (cons 8 (strcat layer "_des"))
	  (cons 100 "AcDbText")
	  (cons	10
		(list (+ (car pt) (* 1.7143 (getvar "textsize")))
		      (- (cadr pt) (* 1.7143 (getvar "textsize")))
		      (caddr pt)
		)
	  )
	  (cons 40 (getvar "textsize"))
	  (cons 1 description)
	  (cons 50 (* (atof rotation) (/ 3.14 180)))
	  (cons 41 1.0)
	  (cons 51 0)
	  (cons 7 style)
	  (cons 71 0)
	  (cons 72 0)
	  (cons 100 "AcDbText")
	  (cons 73 0)
    )
  )
  (ENTMAKE (list (cons 0 "endblk")))
  (ENTMAKE (list (cons 0 "INSERT")
		 (cons 2 "point_block")
		 (cons 10 pt)
	   )
  )
  (loc)
)
(defun loc ()
  (setq
    ent1 (tblsearch "block"
		    (cdr (assoc 2 (setq entkev (entget (entlast)))))
	 )
  )
  (setq rnam (cdr (assoc -1 entkev)))
  (setq namkev (assoc 2 entkev))
  (setq ent1 (subst (cons 2 "*Unnn") (assoc 2 ent1) ent1))
  (setq ent1 (subst (cons 70 1) (assoc 70 ent1) ent1))
  (entmake ent1)
  (setq ent1 (entget (cdr (assoc -2 ent1))))
  (entmake ent1)
  (while (/= ent1 nil)
    (setq ent1 (entnext (cdr (assoc -1 ent1))))
    (if	(/= ent1 nil)
      (progn
	(setq ent1 (entget ent1))
	(entmake ent1)
      )
    )
  )
  (setq l (entmake '((0 . "endblk"))))
  (setq entkev (subst (cons 2 l) (assoc 2 entkev) entkev))
  (entmod entkev)
  (princ)
)

(princ "Type SPOT to use.") (princ)
